<?php

    $dataDir = __DIR__ . '/history';

    $dateFile = $dataDir . '/date.txt';
    $dateCheck = null;
    if (file_exists($dateFile)) {
        $dateString = substr(trim(file_get_contents($dateFile)), 0, 19);
        $dateCheck = \DateTimeImmutable::createFromFormat("Y-m-d H:i:s|", $dateString);
    }


    $sizeFile = $dataDir . '/size.txt';
    $availFile = $dataDir . '/avail.txt';
    $usedFile = $dataDir . '/used.txt';

    $loaded = true
            && file_exists($sizeFile)
            && file_exists($availFile)
            && file_exists($usedFile)
            && true;

    function formatKBytes($kbytes, $precision = 2) {
        $units = array('кило', 'мега', 'гига', 'тера');

        $kbytes = max($kbytes, 0);
        $pow = floor(($kbytes ? log($kbytes) : 0) / log(1024));
        $pow = min($pow, count($units) - 1);

        // Uncomment one of the following alternatives
        // $kbytes /= pow(1024, $pow);
        $kbytes /= (1 << (10 * $pow));

        $num = round($kbytes, $precision);
        return $num . ' ' . $units[$pow] . getWordForm("byte", floor($num));
    }

    function formatDate($date) {
        $today = \DateTimeImmutable::createFromFormat("Y-m-d|", (new \DateTime())->format("Y-m-d"));
        $monthes_gen = array("неизвестного месяца", "января", "февраля", "марта", "апреля", "мая", "июня", "июля", "августа", "сентября", "октября", "ноября", "декабря");

        return ''
             . $date->format("j")
             . ' '
             . $monthes_gen[$date->format("n")]
             . ($date->format("Y") != $today->format("Y") ? (' ' . $date->format("Y")) : '')
             . '';
    }

    function getWordForm($alias, $number) {
        $aliases = array(
            "day" => array(
                '@\b(\d*[02-9])?1\b@' => 'день',
                '@\b(\d*[02-9])?(2|3|4)\b@' => 'дня',
                '@.*@' => 'дней',
            ),
            "byte" => array(
                '@\b(\d*[02-9])?1\b@' => 'байт',
                '@\b(\d*[02-9])?(2|3|4)\b@' => 'байта',
                '@.*@' => 'байтов',
            ),
        );
        $alias_forms = isset($aliases[$alias]) ? $aliases[$alias] : array();

        $form = null;
        foreach ($alias_forms as $regexp => $alias_form) {
            $matched = preg_match($regexp, "$number");

            if ($matched) {
                $form = $alias_form;
                break;
            }
        }

        return $form;
    }

    function buildWeek($when, $startOfWeek, $weekCount) {
        $weeks = array();

        $today = \DateTimeImmutable::createFromFormat("Y-m-d|", (new \DateTime())->format("Y-m-d"));
        $day = $startOfWeek;

        for($w=0; $w<$weekCount; $w++) {
            $weeks[] = '<div>';
            for ($d=0; $d < 7; $d++) {
                if ($d == 5) {
                    $weeks[] = ' &#8203; ';
                }
                if ($day->format("Y-m-d") < $today->format("Y-m-d")) {
                    $weeks[] = '<span class="label">' . $day->format("d") . '</span>' . ' ';
                } elseif ($day->format("Y-m-d") < $when->format("Y-m-d")) {
                    $weeks[] = '<span class="label label-success">' . $day->format("d") . '</span>' . ' ';
                } elseif ($day->format("Y-m-d") == $when->format("Y-m-d")) {
                    $weeks[] = '<span class="label label-warning">' . $day->format("d") . '</span>' . ' ';
                } else {
                    $weeks[] = '<span class="label label-important">' . $day->format("d") . '</span>' . ' ';
                }
                $day = $day->add(new \DateInterval("P1D"));
            }
            $weeks[] = '</div>';
        }

        return implode('', $weeks);
    }

    if ($loaded) {
        $sizeKBytes = (int)file_get_contents($sizeFile);
        $availKBytes = (int)file_get_contents($availFile);
        $usedKBytes = (int)file_get_contents($usedFile);

        $availPercent = $sizeKBytes ? round($availKBytes / $sizeKBytes * 100, 1) : null;
        $usedPercent = round(100 - $availPercent, 1); // sum of avail and used is not size - http://ubuntuforums.org/showthread.php?t=1636659


        $badQ =    1041127;
        $neutralQ = 657985.7561;
        $goodQ =    424608;

        $badDays = round($availKBytes / $badQ);
        $neutralDays = round($availKBytes / $neutralQ);
        $goodDays = round($availKBytes / $goodQ);

#        $today = \DateTimeImmutable::createFromFormat("Y-m-d|", (new \DateTime())->format("Y-m-d"));
        $today = $dateCheck ? (clone $dateCheck) : \DateTimeImmutable::createFromFormat("Y-m-d|", (new \DateTime())->format("Y-m-d"));
        $badInterval = new \DateInterval("P" . $badDays . "D");
        $badDate = $today->add($badInterval)->sub(new\DateInterval("PT1S"));
        $neutralInterval = new \DateInterval("P" . $neutralDays . "D");
        $neutralDate = $today->add($neutralInterval)->sub(new\DateInterval("PT1S"));
        $goodInterval = new \DateInterval("P" . $goodDays . "D");
        $goodDate = $today->add($goodInterval)->sub(new\DateInterval("PT1S"));



        $startOfWeek = \DateTimeImmutable::createFromFormat("Y-m-d|", "2015-11-02");
        $weekCount = 4;




        if (isset($_GET["data"])) {
            switch ($_GET["data"]) {
              case 'avail':
                $val = $availKBytes;
                // $val = rand(0, 492*1024*1024);
                echo json_encode(array(
                    "text" => formatKBytes($val, 2),
                    "value" => $val,
                ));
                break;
            }
            exit;
        }

    }



    // require_once('lib/fcomplex.php');
    // require_once("lib/frole.php");
    // $role = new Role();
    // $role->isPageEnable($user->uuid);

?><!doctype html>
<html lang="ru">
<head>

  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">

  <meta http-equiv="refresh" content="600">

  <title>Мониторинг почтового пространства</title>


  <!-- Framework css -->
  <link rel="stylesheet" type="text/css" href="/css/jquery-ui.css?rand=<?=rand();?>" />
  <link rel="stylesheet" type="text/css" href="/css/bootstrap-combined.min.css?rand=<?=rand();?>" />

  <!-- Wrapper css -->
  <link rel="stylesheet" type="text/css" href="/css/base.css?rand=<?=rand();?>" />
  <link rel="stylesheet" type="text/css" href="/css/member.css?rand=<?=rand();?>" />
  <link rel="stylesheet" type="text/css" href="/css/member.form.css?rand=<?=rand();?>" />
  <!-- Wrapper css -->
  <!--[if gte IE 9]>
    <style type="text/css">
      .gradient {
         filter: none;
      }
    </style>
  <![endif]-->

  <!-- Framework js -->
  <script src="/js/jquery-1.9.1.js"></script>
  <script src="/js/jquery-ui.js"></script>
  <script src="/js/bootstrap.min.js"></script>

  <!-- Wrapper js -->
  <script type="text/javascript">

    var language = "<?=$this->language?>";
    var pageType = "<?=$this->pageType?>";

    var pageId = "<?=$this->pageId?>";

    var userUuid = "<?=$this->user->uuid?>";

  </script>
  <script src="/js/auth.js"></script>

  <script type="text/javascript">
    $(function(){

        updateAvail = window.setInterval(function(){
            var args = [];

            animateContainer = $("#container");
            $.post("?data=avail", args, function(data) {
                console.log(data);
                oldAvail = $("#data-avail").attr("data-avail-value");
                newAvail = data.value;
                availColor = null;
                opacity = 0.26;
                if (data.text != $("#data-avail").text()) {
                    //  && data.value <= 1048576
                    if (newAvail > oldAvail) {
                        availColor = "rgba(29, 255, 80, " + opacity + ")";
                    } else if (newAvail < oldAvail) {
                        availColor = "rgba(255, 29, 29, " + opacity + ")";
                    }
                } else {
                    // availColor = "rgba(104, 104, 104, " + opacity + ")";
                }

                if (availColor) {
                    animateContainer.animate({
                      // width: "70%",
                      // opacity: 0.4,
                      // marginLeft: "0.6in",
                      // fontSize: "3em",
                      // borderWidth: "10px",
                      "backgroundColor": availColor
                    }, 100, "swing", function() {
                        $("#data-avail").text(data.text);
                        $("#data-avail").attr("data-avail-value", data.value);

                        animateContainer.animate({
                          "backgroundColor": "transparent"
                        }, 800, "swing");
                    })
                }
            }, "json")
        }, 2000)

    })

  </script>

  <!-- Hosting css -->
  <link rel="stylesheet" type="text/css" href="/css/hosting/hosting.css?rand=<?=rand();?>" />
  <link rel="stylesheet" type="text/css" href="/css/hosting/monitor.css?rand=<?=rand();?>" />

  <style type="text/css" media="screen">
      object { outline:none; }
  </style>
</head>

<body>
  <div id="container" style="position: fixed; left: 0; right: 0; top: 0; bottom: 0; z-index: 0;">

<!-- USERBOX -->

<header class="header gradient">
  <div class="header__logo">
    <img src="/images/herzen.png" />
  </div>
  <div class="header__headings">
    <h1 class="header__headings__heading">
      Мониторинг почтового пространства
    </h1>
    <h2 class="header__headings__subheading">
      <?php if ($dateCheck): ?>
          Последняя проверка выполнена в <?=$dateCheck->format("H:i d.m.Y")?>
      <?php else: ?>
          Проверка еще не запускалась
      <?php endif; ?>
    </h2>
  </div>

  <div class="userbox userbox_parent_header">
    <div class="userbox__controls">
      <span class="userbox__controls__profile">профиль</span> / <span class="userbox__controls__logout">выход</span>
    </div>
    <div class="userbox__username">
        <span class="userbox__username__displayname" data-uuid="<?=$this->user->uuid?>"><?=$this->user->givenname?> <?=$this->user->lastname?></span>
    </div>
  </div>

  <div class="header__helper"></div>
</header>

<div class = "left">
    <?=(isset($role) ? $role->userMenu($user->uuid) : '');?>
</div>

<?=$this->renderNavigation();?>

<div class="page__helper"></div>

<?php if ($this->canViewMonitor()): ?>

    <?php if ($loaded): ?>

<div>
  <div class="center-container">
    <h1><small>На почтовом сервере осталось</small></h1>
    <h1 id="data-avail" data-avail-value="<?=$availKBytes?>"><?=formatKBytes($availKBytes, 2)?></h1>
    <style>
      .progress-disk-size:after {
        /*content: '<?=formatKBytes($sizeKBytes, 0)?>';*/
      }
    </style>
    <div style="width: 50%; margin: auto; "><!--
      <div class="progress progress-disk-size" style="border: 1px solid #adadad;">
        <div class="bar bar-danger" style="width: <?=$usedPercent?>%;"><?=$usedPercent?>%</div>
      </div> -->
      <div class="progress progress-disk-size" style="border: 1px solid #adadad;">
        <div class="bar bar-danger" style="text-align: right; width: <?=$usedPercent?>%;"><?=$usedPercent?>%&nbsp;</div>
      </div>
    </div>
    <h2><small>Общий объем диска &mdash; <?=formatKBytes($sizeKBytes, 0)?></small></h2>
  </div>

  <div class="center-container">
    <h2>До отключения почтового сервера осталось</h2>

    <div class="row-fluid">
      <div class="span4">
        <h2 class="badge badge-important">Пессимистичный прогноз</h2>
        <h3>
          <?=$badInterval->format("%d")?>
          <?=getWordForm("day", $badInterval->format("%d"))?>
        </h3>
        <p>места хватит до <?=formatDate($badDate)?></p>

        <?=buildWeek($badDate, $startOfWeek, $weekCount)?>

        <!-- <p><a class="btn btn-primary btn-lg" href="#" role="button">Почему так?</a></p> -->
      </div>
      <div class="span4">
        <h2 class="badge badge-warning">Нейтральный прогноз</h2>
        <h3>
          <?=$neutralInterval->format("%d")?>
          <?=getWordForm("day", $neutralInterval->format("%d"))?>
        </h3>
        <p>места хватит до <?=formatDate($neutralDate)?></p>

        <?=buildWeek($neutralDate, $startOfWeek, $weekCount)?>

        <!-- <p><a class="btn btn-primary btn-lg" href="#" role="button">Почему так?</a></p> -->
      </div>
      <div class="span4">
        <h2 class="badge badge-success">Оптимистичный прогноз</h2>
        <h3>
          <?=$goodInterval->format("%d")?>
          <?=getWordForm("day", $goodInterval->format("%d"))?>
        </h3>
        <p>места хватит до <?=formatDate($goodDate)?></p>

        <?=buildWeek($goodDate, $startOfWeek, $weekCount)?>

        <!-- <p><a class="btn btn-primary btn-lg" href="#" role="button">Почему так?</a></p> -->
      </div>
    </div>
  </div>
</div>

    <?php else: ?>

        <div class="not-found">
          <h1>Данные еще не загружены</h1>
          <p>Вернитесь сюда позже или <a target="_blank" href="mailto:monitoring@herzen.spb.ru?subject=Данные мониторинга почты не загружены!">сообщите об ошибке по электронной почте</a></p>

          <p><a href="?">Главная страница</a> | <a href="javascript:history.go(-1);">Вернуться назад</a></p>
        </div>
    <?php endif; ?>

  <script src="/js/hosting/jquery.fittext.js"></script>


  <?php if (file_exists(__DIR__ . '/Monitor.charts.inc.html')): ?>
      <?php require __DIR__ . '/Monitor.charts.inc.html'; ?>
  <?php endif; ?>

  <script src="/js/highcharts/js/highcharts.js"></script>
  <script src="/js/highcharts/js/highcharts-more.js"></script>
  <script src="/js/highcharts/js/modules/exporting.js"></script>

<?php else: ?>

<div id="forbidden" class="forbidden">
  <h1>Доступ не разрешен</h1>
  <p>Попробуйте <a target="_blank" href="mailto:monitoring@herzen.spb.ru?subject=О доступе к мониторингу почты">запросить доступ по электронной почте</a></p>

  <p><a href="?">Главная страница</a> | <a href="javascript:history.go(-1);">Вернуться назад</a></p>
</div>
<?php endif; ?>
  </div>

</body>
</html>
